/* valadeclarationstatement.c generated by valac, the Vala compiler
 * generated from valadeclarationstatement.vala, do not modify */

/* valadeclarationstatement.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <valagee.h>
#include <glib-object.h>
#include <glib.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

struct _ValaDeclarationStatementPrivate {
	ValaSymbol* _declaration;
};

static gint ValaDeclarationStatement_private_offset;
static gpointer vala_declaration_statement_parent_class = NULL;
static ValaStatementIface * vala_declaration_statement_vala_statement_parent_iface = NULL;

static void vala_declaration_statement_real_accept (ValaCodeNode* base,
                                             ValaCodeVisitor* visitor);
static void vala_declaration_statement_real_accept_children (ValaCodeNode* base,
                                                      ValaCodeVisitor* visitor);
static void vala_declaration_statement_real_get_error_types (ValaCodeNode* base,
                                                      ValaCollection* collection,
                                                      ValaSourceReference* source_reference);
static gboolean vala_declaration_statement_real_check (ValaCodeNode* base,
                                                ValaCodeContext* context);
static void vala_declaration_statement_real_emit (ValaCodeNode* base,
                                           ValaCodeGenerator* codegen);
static void vala_declaration_statement_real_get_defined_variables (ValaCodeNode* base,
                                                            ValaCollection* collection);
static void vala_declaration_statement_real_get_used_variables (ValaCodeNode* base,
                                                         ValaCollection* collection);
static void vala_declaration_statement_finalize (ValaCodeNode * obj);

static inline gpointer
vala_declaration_statement_get_instance_private (ValaDeclarationStatement* self)
{
	return G_STRUCT_MEMBER_P (self, ValaDeclarationStatement_private_offset);
}

/**
 * Creates a new declaration statement.
 *
 * @param declaration       local variable declaration
 * @param source_reference  reference to source code
 * @return                  newly created declaration statement
 */
ValaDeclarationStatement*
vala_declaration_statement_construct (GType object_type,
                                      ValaSymbol* declaration,
                                      ValaSourceReference* source_reference)
{
	ValaDeclarationStatement* self = NULL;
	g_return_val_if_fail (declaration != NULL, NULL);
	self = (ValaDeclarationStatement*) vala_code_node_construct (object_type);
	vala_declaration_statement_set_declaration (self, declaration);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source_reference);
	return self;
}

ValaDeclarationStatement*
vala_declaration_statement_new (ValaSymbol* declaration,
                                ValaSourceReference* source_reference)
{
	return vala_declaration_statement_construct (VALA_TYPE_DECLARATION_STATEMENT, declaration, source_reference);
}

static void
vala_declaration_statement_real_accept (ValaCodeNode* base,
                                        ValaCodeVisitor* visitor)
{
	ValaDeclarationStatement * self;
	self = (ValaDeclarationStatement*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_declaration_statement (visitor, self);
}

static void
vala_declaration_statement_real_accept_children (ValaCodeNode* base,
                                                 ValaCodeVisitor* visitor)
{
	ValaDeclarationStatement * self;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	self = (ValaDeclarationStatement*) base;
	g_return_if_fail (visitor != NULL);
	_tmp0_ = vala_declaration_statement_get_declaration (self);
	_tmp1_ = _tmp0_;
	vala_code_node_accept ((ValaCodeNode*) _tmp1_, visitor);
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static void
vala_declaration_statement_real_get_error_types (ValaCodeNode* base,
                                                 ValaCollection* collection,
                                                 ValaSourceReference* source_reference)
{
	ValaDeclarationStatement * self;
	ValaLocalVariable* local = NULL;
	ValaSymbol* _tmp2_;
	ValaSymbol* _tmp3_;
	ValaLocalVariable* _tmp4_;
	gboolean _tmp5_ = FALSE;
	ValaLocalVariable* _tmp6_;
	self = (ValaDeclarationStatement*) base;
	g_return_if_fail (collection != NULL);
	if (source_reference == NULL) {
		ValaSourceReference* _tmp0_;
		ValaSourceReference* _tmp1_;
		_tmp0_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp1_ = _tmp0_;
		source_reference = _tmp1_;
	}
	_tmp2_ = vala_declaration_statement_get_declaration (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, VALA_TYPE_LOCAL_VARIABLE) ? ((ValaLocalVariable*) _tmp3_) : NULL);
	local = _tmp4_;
	_tmp6_ = local;
	if (_tmp6_ != NULL) {
		ValaLocalVariable* _tmp7_;
		ValaExpression* _tmp8_;
		ValaExpression* _tmp9_;
		_tmp7_ = local;
		_tmp8_ = vala_variable_get_initializer ((ValaVariable*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp5_ = _tmp9_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		ValaLocalVariable* _tmp10_;
		ValaExpression* _tmp11_;
		ValaExpression* _tmp12_;
		_tmp10_ = local;
		_tmp11_ = vala_variable_get_initializer ((ValaVariable*) _tmp10_);
		_tmp12_ = _tmp11_;
		vala_code_node_get_error_types ((ValaCodeNode*) _tmp12_, collection, source_reference);
	}
	_vala_code_node_unref0 (local);
}

static gboolean
vala_declaration_statement_real_check (ValaCodeNode* base,
                                       ValaCodeContext* context)
{
	ValaDeclarationStatement * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaSymbol* _tmp4_;
	ValaSymbol* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	self = (ValaDeclarationStatement*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_declaration_statement_get_declaration (self);
	_tmp5_ = _tmp4_;
	vala_code_node_check ((ValaCodeNode*) _tmp5_, context);
	_tmp6_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp7_ = _tmp6_;
	result = !_tmp7_;
	return result;
}

static void
vala_declaration_statement_real_emit (ValaCodeNode* base,
                                      ValaCodeGenerator* codegen)
{
	ValaDeclarationStatement * self;
	self = (ValaDeclarationStatement*) base;
	g_return_if_fail (codegen != NULL);
	vala_code_visitor_visit_declaration_statement ((ValaCodeVisitor*) codegen, self);
}

static void
vala_declaration_statement_real_get_defined_variables (ValaCodeNode* base,
                                                       ValaCollection* collection)
{
	ValaDeclarationStatement * self;
	ValaLocalVariable* local = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	ValaLocalVariable* _tmp2_;
	ValaLocalVariable* _tmp3_;
	self = (ValaDeclarationStatement*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_declaration_statement_get_declaration (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, VALA_TYPE_LOCAL_VARIABLE) ? ((ValaLocalVariable*) _tmp1_) : NULL);
	local = _tmp2_;
	_tmp3_ = local;
	if (_tmp3_ != NULL) {
		ValaArrayType* array_type = NULL;
		ValaLocalVariable* _tmp4_;
		ValaDataType* _tmp5_;
		ValaDataType* _tmp6_;
		ValaArrayType* _tmp7_;
		ValaLocalVariable* _tmp8_;
		ValaExpression* _tmp9_;
		ValaExpression* _tmp10_;
		_tmp4_ = local;
		_tmp5_ = vala_variable_get_variable_type ((ValaVariable*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, VALA_TYPE_ARRAY_TYPE) ? ((ValaArrayType*) _tmp6_) : NULL);
		array_type = _tmp7_;
		_tmp8_ = local;
		_tmp9_ = vala_variable_get_initializer ((ValaVariable*) _tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ != NULL) {
			ValaLocalVariable* _tmp11_;
			ValaExpression* _tmp12_;
			ValaExpression* _tmp13_;
			ValaLocalVariable* _tmp14_;
			_tmp11_ = local;
			_tmp12_ = vala_variable_get_initializer ((ValaVariable*) _tmp11_);
			_tmp13_ = _tmp12_;
			vala_code_node_get_defined_variables ((ValaCodeNode*) _tmp13_, collection);
			_tmp14_ = local;
			vala_collection_add (collection, (ValaVariable*) _tmp14_);
		} else {
			gboolean _tmp15_ = FALSE;
			ValaArrayType* _tmp16_;
			_tmp16_ = array_type;
			if (_tmp16_ != NULL) {
				ValaArrayType* _tmp17_;
				gboolean _tmp18_;
				gboolean _tmp19_;
				_tmp17_ = array_type;
				_tmp18_ = vala_array_type_get_fixed_length (_tmp17_);
				_tmp19_ = _tmp18_;
				_tmp15_ = _tmp19_;
			} else {
				_tmp15_ = FALSE;
			}
			if (_tmp15_) {
				ValaLocalVariable* _tmp20_;
				_tmp20_ = local;
				vala_collection_add (collection, (ValaVariable*) _tmp20_);
			}
		}
		_vala_code_node_unref0 (array_type);
	}
	_vala_code_node_unref0 (local);
}

static void
vala_declaration_statement_real_get_used_variables (ValaCodeNode* base,
                                                    ValaCollection* collection)
{
	ValaDeclarationStatement * self;
	ValaLocalVariable* local = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	ValaLocalVariable* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ValaLocalVariable* _tmp4_;
	self = (ValaDeclarationStatement*) base;
	g_return_if_fail (collection != NULL);
	_tmp0_ = vala_declaration_statement_get_declaration (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, VALA_TYPE_LOCAL_VARIABLE) ? ((ValaLocalVariable*) _tmp1_) : NULL);
	local = _tmp2_;
	_tmp4_ = local;
	if (_tmp4_ != NULL) {
		ValaLocalVariable* _tmp5_;
		ValaExpression* _tmp6_;
		ValaExpression* _tmp7_;
		_tmp5_ = local;
		_tmp6_ = vala_variable_get_initializer ((ValaVariable*) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp3_ = _tmp7_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		ValaLocalVariable* _tmp8_;
		ValaExpression* _tmp9_;
		ValaExpression* _tmp10_;
		_tmp8_ = local;
		_tmp9_ = vala_variable_get_initializer ((ValaVariable*) _tmp8_);
		_tmp10_ = _tmp9_;
		vala_code_node_get_used_variables ((ValaCodeNode*) _tmp10_, collection);
	}
	_vala_code_node_unref0 (local);
}

ValaSymbol*
vala_declaration_statement_get_declaration (ValaDeclarationStatement* self)
{
	ValaSymbol* result;
	ValaSymbol* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_declaration;
	result = _tmp0_;
	return result;
}

void
vala_declaration_statement_set_declaration (ValaDeclarationStatement* self,
                                            ValaSymbol* value)
{
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_declaration);
	self->priv->_declaration = _tmp0_;
	_tmp1_ = self->priv->_declaration;
	if (_tmp1_ != NULL) {
		ValaSymbol* _tmp2_;
		_tmp2_ = self->priv->_declaration;
		vala_code_node_set_parent_node ((ValaCodeNode*) _tmp2_, (ValaCodeNode*) self);
	}
}

static void
vala_declaration_statement_class_init (ValaDeclarationStatementClass * klass)
{
	vala_declaration_statement_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_declaration_statement_finalize;
	g_type_class_adjust_private_offset (klass, &ValaDeclarationStatement_private_offset);
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_declaration_statement_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_declaration_statement_real_accept_children;
	((ValaCodeNodeClass *) klass)->get_error_types = (void (*) (ValaCodeNode*, ValaCollection*, ValaSourceReference*)) vala_declaration_statement_real_get_error_types;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_declaration_statement_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode*, ValaCodeGenerator*)) vala_declaration_statement_real_emit;
	((ValaCodeNodeClass *) klass)->get_defined_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_declaration_statement_real_get_defined_variables;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_declaration_statement_real_get_used_variables;
}

static void
vala_declaration_statement_vala_statement_interface_init (ValaStatementIface * iface)
{
	vala_declaration_statement_vala_statement_parent_iface = g_type_interface_peek_parent (iface);
}

static void
vala_declaration_statement_instance_init (ValaDeclarationStatement * self)
{
	self->priv = vala_declaration_statement_get_instance_private (self);
}

static void
vala_declaration_statement_finalize (ValaCodeNode * obj)
{
	ValaDeclarationStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_DECLARATION_STATEMENT, ValaDeclarationStatement);
	_vala_code_node_unref0 (self->priv->_declaration);
	VALA_CODE_NODE_CLASS (vala_declaration_statement_parent_class)->finalize (obj);
}

/**
 * Represents a local variable or constant declaration statement in the source code.
 */
GType
vala_declaration_statement_get_type (void)
{
	static volatile gsize vala_declaration_statement_type_id__volatile = 0;
	if (g_once_init_enter (&vala_declaration_statement_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaDeclarationStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_declaration_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaDeclarationStatement), 0, (GInstanceInitFunc) vala_declaration_statement_instance_init, NULL };
		static const GInterfaceInfo vala_statement_info = { (GInterfaceInitFunc) vala_declaration_statement_vala_statement_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType vala_declaration_statement_type_id;
		vala_declaration_statement_type_id = g_type_register_static (VALA_TYPE_CODE_NODE, "ValaDeclarationStatement", &g_define_type_info, 0);
		g_type_add_interface_static (vala_declaration_statement_type_id, VALA_TYPE_STATEMENT, &vala_statement_info);
		ValaDeclarationStatement_private_offset = g_type_add_instance_private (vala_declaration_statement_type_id, sizeof (ValaDeclarationStatementPrivate));
		g_once_init_leave (&vala_declaration_statement_type_id__volatile, vala_declaration_statement_type_id);
	}
	return vala_declaration_statement_type_id__volatile;
}

